import { GrpcClientCtor } from './GrpcClient';
import { ZBLoggerConfig } from './interfaces-1.0';
import { StatefulLogInterceptor } from './StatefulLogInterceptor';
export declare type GrpcConnectionProfile = 'CAMUNDA_CLOUD' | 'VANILLA';
export interface Characteristics {
    startupTime: number;
    _tag: GrpcConnectionProfile;
}
export declare const ConnectionCharacteristics: {
    [key in GrpcConnectionProfile]: Characteristics;
};
export declare type State = 'ERROR' | 'CONNECTED' | 'UNKNOWN';
export declare class ConnectionFactory {
    static getGrpcClient({ grpcConfig, logConfig, }: {
        grpcConfig: GrpcClientCtor;
        logConfig: ZBLoggerConfig;
    }): {
        grpcClient: import("./GrpcClient").GrpcClient;
        log: StatefulLogInterceptor;
    };
    private static getCharacteristics;
}
