"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.cancelProcesses = void 0;
const operate_api_client_1 = require("operate-api-client");
const operate = createClient();
async function cancelProcesses(processDefinitionKey) {
    if (!operate) {
        return;
    }
    const processes = await operate.searchProcessInstances({
        filter: {
            processDefinitionKey: +processDefinitionKey
        }
    });
    await Promise.all(processes.items.map(item => operate.deleteProcessInstance(+item.bpmnProcessId)));
}
exports.cancelProcesses = cancelProcesses;
function createClient() {
    try {
        return new operate_api_client_1.OperateApiClient();
    }
    catch (e) {
        // console.log(e.message)
        // console.log(`Running without access to Operate`)
        return null;
    }
}
//# sourceMappingURL=cancelProcesses.js.map